/*  eto_sql_pg_create_db.sql  20150812 (c) Copyright 2015 A.S.Petrie. All rights reserved. ...
  
    SQL -- Create ETO PostgreSQL database.
*/

CREATE DATABASE eto_sql_db WITH ENCODING 'UTF8';

\connect eto_sql_db

CREATE SCHEMA its_eto;

CREATE TABLE its_eto.eto_sql_tb_session_www
(
  session_www_code       char(32)      NOT NULL UNIQUE PRIMARY KEY,

  session_www_type       int           NOT NULL,
  session_www_state      int           NOT NULL,
  session_verify_code    char(7)       NOT NULL,

  session_www_serno      SERIAL        NOT NULL UNIQUE,

  session_target_serno   int           NULL,
  session_target_data    varchar(1000) NULL,

  session_www_init_utc   timestamp     NOT NULL,
  session_www_last_utc   timestamp     NOT NULL,
  session_www_expiry_utc timestamp     NOT NULL,
  session_www_delete_utc timestamp     NOT NULL,
  session_www_hit_count  int           NOT NULL,
  session_www_act_seqno  int           NULL

);

CREATE INDEX ON its_eto.eto_sql_tb_session_www (session_www_serno);


CREATE TABLE its_eto.eto_sql_tb_contact_msg
(
  contact_msg_serno    SERIAL        NOT NULL UNIQUE PRIMARY KEY,

  contact_msg_status   int           NOT NULL,
  
  contact_session_code char(32)      NOT NULL,
  contact_verify_code  char(7)       NOT NULL,
  
  contact_source_serno int           NULL,
  contact_privacy      int           NOT NULL,

  contact_first_name   varchar(30)   NOT NULL,
  contact_last_name    varchar(30)   NOT NULL,
  contact_email_addr   varchar(256)  NOT NULL,
  contact_msg_subject  varchar(60)   NOT NULL,
  contact_message      varchar(2000) NOT NULL,

  contact_msg_init_utc timestamp     NOT NULL

);


CREATE TABLE its_eto.eto_sql_tb_club_member
(
  club_member_serno         SERIAL        NOT NULL UNIQUE PRIMARY KEY,

  member_status             int           NOT NULL,
  member_password           varchar(60)   NOT NULL,

  member_session_code       char(32)      NOT NULL,
  member_verify_code        char(7)       NOT NULL,

  member_first_name         varchar(30)   NOT NULL,
  member_last_name          varchar(30)   NOT NULL,
  member_email_addr         varchar(256)  NOT NULL,
  member_ref_by_member      int           NOT NULL,
  member_inf_by_advert      int           NOT NULL,

  member_reserve_coop_spot  boolean       NOT NULL,
  member_request_news_email boolean       NOT NULL,
  member_block_email_login  boolean       NOT NULL,

  club_member_init_utc      timestamp     NOT NULL,
  club_member_last_utc      timestamp     NOT NULL,
  club_member_expiry_utc    timestamp     NOT NULL,
  club_member_notified_utc  char(19)      NOT NULL  /* allow '0000-00-00 00:00:00'. */

);

CREATE INDEX ON its_eto.eto_sql_tb_club_member (member_email_addr);

/* ... eto_sql_pg_create_db.sql */
