<?php

//	eto__abend_ssi_0.php 20151002 (c) Copyright 2014 A.S.Petrie. All rights reserved.
//
//	SSI -- Abend service option settings, common variables and functions.
//
//	Option settings, variables and common functions.
  require '../eto_php/eto__chron_ssi_0.php';

// Constants for function abend code mapping (php source code file generated by <eto__abend_con_1.php>).
require '../eto_php/eto__abend_ssi_9.php';

// Common variables ...

$sys_script_id     = '';
$sys_log_details   = '';   // variable function name => script-specific log items (returns string value).
$sys_log_det_val   = '';   // string with details of => script-specific log items (stored by function etoSQLdbClose($ac) calling function named in $sys_log_details).
$sys_start_time    = 0.0;  // ** CAUTION -- OVERFLOW ** With machine 32-bit float rep. overflow occurs on January 19, 2038 => MUST be on 64-bit machine to avoid;

$sys_exit_code     = 0; // 32-bit signed integer.

// derived from final exit code ...
$sys_exit_app_code  = 0; // value from 0 ... 65535 16-bit no.
$sys_exit_flags_str = '0000000000000000'; // string rep of 16-bit no.
// ... derived from final exit code.

$sys_exit_msg      = '';

$sys_log_msg       = '';
$sys_log_priority  = '';
$sys_log_pr_name   = '';
$sys_log_dir_name  = "I:\\APPS\\XAMPP\\xampp_1_7_3\\xampp\\apache\\logs";
// $sys_log_dir_name = '';
$sys_log_line_end  = "\r\n"; // Windows line-end.
$sys_log_dir_sep   = "\\";   // Windows directory name separator in file names.
$sys_log_file_path = '';     // fully qualified system log file name.

// ... Common variables.

// Constants for functions in this SSI ...

const SYS_LOG_VAR_NAME = "\$sys_exit_msg"; // ** CAUTION ** Keep in sync with active use of variable in funcion etoExit_encap_log_msg().

      $SYS_LOG_PREFIX
      =
      (
         '[' . "$crn_dtime_utc" . ' ' . "$crn_dow_utc" . ' ' . "$crn_offset_loc" . '] ' .

         'ETO ' .

         SYS_LOG_VAR_NAME
      );

      $SYS_LOG_VAR_ALIGN     = strlen($SYS_LOG_PREFIX);

const SYS_LOG_NAME          = 'eto_syslog';
const SYS_LOG_MSG_MAX_LEN   = 500;

const ERROR_LOG_MSG_MAX_LEN = 1024;
// const HTTP_LOG_MSG_MAX_LEN = 1024;

//
// function stat() used in function etoExit_syslog_file().
//
// http://www.hmug.org/man/2/stat.html (the following information about the mode bits) ...
//
// #define S_IFMT 0170000           /* type of file */
// #define        S_IFIFO  0010000  /* named pipe (fifo) */
// #define        S_IFCHR  0020000  /* character special */
// #define        S_IFDIR  0040000  /* directory */
// #define        S_IFBLK  0060000  /* block special */
// #define        S_IFREG  0100000  /* regular */
// #define        S_IFLNK  0120000  /* symbolic link */
// #define        S_IFSOCK 0140000  /* socket */
// #define        S_IFWHT  0160000  /* whiteout */
// #define S_ISUID 0004000  /* set user id on execution */
// #define S_ISGID 0002000  /* set group id on execution */
// #define S_ISVTX 0001000  /* save swapped text even after use */
// #define S_IRUSR 0000400  /* read permission, owner */
// #define S_IWUSR 0000200  /* write permission, owner */
// #define S_IXUSR 0000100  /* execute/search permission, owner */
//
// Note that these numbers are in octal format.
//
   const FSTAT_S_IFMT  = 0170000;
   const FSTAT_S_IFDIR = 0040000;
   const FSTAT_S_IFREG = 0100000;

// ... Constants for functions in this SSI.

// syslog priorities ...

// Linux ...
// define_syslog_variables() -- deprecated function.
// ... Linux.

// Windows ...
// const LOG_INFO = 6;
// const LOG_ERR  = 1;
// ... Windows.

// ... syslog priorities.

// Option parameter for functions in this SSI.
const ABEND_NOEXIT     = false;
const ABEND_EXIT       = true;
const ABEND_NOROLLBACK = false;
const ABEND_ROLLBACK   = true;

// exit code increment values.
const INT_BIT_17 = 0x00010000; // etoSQLtrxRollback(...) failed - called from etoAbendReal(...).
const INT_BIT_18 = 0x00020000; // etoSQLdbClose(...)     failed - called from etoAbendReal(...).
const INT_BIT_19 = 0x00040000; // error_log(...)         failed - called from etoExit_error_log(...).
const INT_BIT_20 = 0x00080000; // stat(...) directory - wrong mode returned - Windows: called from etoExit_syslog_file(...).
const INT_BIT_21 = 0x00100000; // stat(...)     directory - call incomplete - Windows: called from etoExit_syslog_file(...).
const INT_BIT_22 = 0x00200000; // fopen(...)             failed - Windows: called from etoExit_syslog_file(...).
const INT_BIT_23 = 0x00400000; // stat(...)      file - wrong mode returned - Windows: called from etoExit_syslog_file(...).
const INT_BIT_24 = 0x00800000; // stat(...)          file - call incomplete - Windows: called from etoExit_syslog_file(...).
const INT_BIT_25 = 0x01000000; // fwrite(...)            failed - Windows: called from etoExit_syslog_file(...).
const INT_BIT_26 = 0x02000000; // fclose(...)            failed - Windows: called from etoExit_syslog_file(...).
const INT_BIT_27 = 0x04000000; // openlog(...)           failed - NOT Windows => Function etoExit_syslog_real(...).
const INT_BIT_28 = 0x08000000; // syslog(...)            failed - NOT Windows => Function etoExit_syslog_real(...).
const INT_BIT_29 = 0x10000000; // closelog(...)          failed - NOT Windows => Function etoExit_syslog_real(...).
const INT_BIT_30 = 0x20000000; // unused.
const INT_BIT_31 = 0x40000000; // unused.

// --------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------
//       *** $sys_exit_code ABEND CODE VALUES CURRENTLY USED ***
// --------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------
//
//                *** IMPORTANT NOTE ***
//
//      ($sys_exit_code -- 32-bit signed integer precision -2147483648 to 2147483647.)
// 
// The 32-bit signed intger exit code is partitioned into two 16-bit components:
//
//    low-order 16 bits -  application exit code (0 ... 65535):
// 
//      => 0           == application successful completion.
//      => 1 ... 65535 == application failed.
// 
//    high-order 16 bits - exit handler failure flags (16 flags == 0/1):
// 
//      => adding (const) INT_BIT_xx value(s) to application exit code.
// 
// --------------------------------------------------------------------------------------------------------------------
//           exit handler             application
//           ailure flags              exit code
// ------------------------------- ----------------
//       high-order 16 bits        low-order 16 bits
// - - - - - - - - - - - - - - - - ----------------
// 3 3 3 2 2 2 2 2 2 2 2 2 1 1 1 1 1111110000000000
// 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6543210987654321
// - - - - - - - - - - - - - - - - ----------------
// b b b b b b b b b b b b b b b b iiiiiiiiiiiiiiii
// - - - - - - - - - - - - - - - - ----------------
// | | | | | | | | | | | | | | | | | ERRORS IN APPLICATION ...
// | | | | | | | | | | | | | | | | ----------------
// | | | | | | | | | | | | | | | | (0 ... 65535) application exit code.
// | | | | | | | | | | | | | | | | ----------------
// | | | | | | | | | | | | | | | |  ERRORS IN ABEND HANDLER ...
// | | | | | | | | | | | | | | | | ----------------
// | | | | | | | | | | | | | | | + (0/1) etoSQLtrxRollback(...) failed - called from etoAbendReal(...).
// | | | | | | | | | | | | | | +-- (0/1) etoSQLdbClose(...)     failed - called from etoAbendReal(...).
// | | | | | | | | | | | | | | ----------------
// | | | | | | | | | | | | | +---- (0/1) error_log(...)         failed - called from etoExit_error_log(...).
// | | | | | | | | | | | | | ------------------
// | | | | | | | | | | | | +------ (0/1) stat(...) directory - wrong mode returned - Windows: called from etoExit_syslog_file(...).
// | | | | | | | | | | | +-------- (0/1) stat(...)     directory - call incomplete - Windows: called from etoExit_syslog_file(...).
// | | | | | | | | | | +---------- (0/1) fopen(...)                         failed - Windows: called from etoExit_syslog_file(...).
// | | | | | | | | | +------------ (0/1) stat(...)      file - wrong mode returned - Windows: called from etoExit_syslog_file(...).
// | | | | | | | | +-------------- (0/1) stat(...)          file - call incomplete - Windows: called from etoExit_syslog_file(...).
// | | | | | | | +---------------- (0/1) fwrite(...)            failed - Windows: called from etoExit_syslog_file(...).
// | | | | | | +------------------ (0/1) fclose(...)            failed - Windows: called from etoExit_syslog_file(...).
// | | | | | | ------------------------------
// | | | | | +-------------------- (0/1) openlog(...)           failed - NOT Windows => Function etoExit_syslog_real(...).
// | | | | +---------------------- (0/1) syslog(...)            failed - NOT Windows => Function etoExit_syslog_real(...).
// | | | +------------------------ (0/1) closelog(...)          failed - NOT Windows => Function etoExit_syslog_real(...).
// | | | ------------------------------------
// | | +-------------------------- (0/1) unused.
// | +---------------------------- (0/1) unused.
// | ------------------------------------------
// +------------------------------ (0/1) sign bit unused.
// --------------------------------------------------------------------------------------------------------------------
//
/* OBSOLETE ...
//
//    Function etoAbendReal(...) will increment $sys_exit_code by:
//
//         2000 -- to indicate failure of etoSQLtrxRollback(...) => max $sys_exit_code generated by an eto app main function == 1647 by eto_club_eto_act_1().
//
//        10000 -- to indicate failure of etoSQLdbClose(...).
//
//
//    Function etoExit_error_log(...) will increment $sys_exit_code by:
//
//       100000 -- to indicate failure of error_log(...).
//
//
//    Windows => Function etoExit_syslog_file(...) will increment $sys_exit_code by:
//
//       200000 -- to indicate failure of stat(...) -- wrong mode returned.
//       400000 -- to indicate failure of stat(...) -- call failed.
//
//      1000000 -- to indicate failure of fopen(...).
//
//     10000000 -- to indicate failure of stat(...) -- wrong mode returned.
//     20000000 -- to indicate failure of stat(...) -- call failed.
//
//    100000000 -- to indicate failure of fwrite(...).
//
//   1000000000 -- to indicate failure of fclose(...).
//
//
//    NOT Windows => Function etoExit_syslog_real(...) will increment $sys_exit_code by:
//
//       200000 -- to indicate failure of openlog(...).
//
//      1000000 -- to indicate failure of syslog(...).
//
//     10000000 -- to indicate failure of closelog(...).
//
... OBSOLETE. */

//
// --------------------------------------------------------------------------------------


// Functions ...

function etoExit()
{
   global $ses_code;
   global $sys_exit_code;

// Compose the system log message.
   etoExit_sys_log_msg();

// Set the system log message priority.
   etoExit_sys_log_priority();

// Record ALL terminations in the eto application ACTIVITY system log.
   etoExit_syslog();

// Record ABNORMAL terminations in the HTTP / PHP server error log.
   ($sys_exit_code)
   ?
   (
      etoExit_error_log()
   )
   :  false
   ;

// Failure of error recovery / logging?
   if ($sys_exit_code > (INT_BIT_17 - 1))
// if ($sys_exit_code > 999)
// yes -- error recovery / logging failed.
   {
//    Display $sys_exit_code on client browser.
      echo htmlspecialchars('$sys_exit_code<' . $sys_exit_code . '>', ENT_QUOTES);
   }

/*
// Testing ...
   global $sys_log_msg;
   global $sys_log_dir_name;
   global $sys_log_file_path;

   $tst_diag = '';
   $tst_diag .= ( '##etoExit()##  ' );

   $tst_diag .= ( '**$sys_log_dir_name<' . $sys_log_dir_name . '>** ' );
   $tst_diag .= ( '**$sys_log_file_path<' . $sys_log_file_path . '>**' );

   $tst_diag .= ( '**$sys_exit_code<' . $sys_exit_code . '>** ' );
   $tst_diag .= ( '**$sys_log_msg<' . $sys_log_msg . '>**' );

   echo htmlspecialchars($tst_diag, ENT_QUOTES);
// ... Testing.
*/

// apache environment variable for apache httpd access log.
   apache_setenv("PHP_ETO_SES_CODE", "$ses_code");


   exit($sys_exit_code);
}

function etoExit_sys_log_priority()
{
   global $sys_exit_code;
   global $sys_log_priority;
   global $sys_log_pr_name;

   $sys_log_priority = LOG_INFO;

   switch($sys_exit_code)
   {
      case 0;
      {
         $sys_log_priority = LOG_INFO;
         $sys_log_pr_name  = 'LOG_INFO';
      }

      default:
      {
         $sys_log_priority = LOG_ERR;
         $sys_log_pr_name  = 'LOG_ERR';
      }
   }

   return;
}

function etoExit_sys_log_indent_det($is) // input string with leftmost '#' marking alignment point (e.g. "\$sys_exit_code<").
{
   global $SYS_LOG_VAR_ALIGN;

   $strpos_tmp = strpos($is, '#');

   return
   (
      (
//       '#' char found?
         (!($strpos_tmp === false))
//       yes -- '#' char found.
         ?
         (
//          is padding needed?
            ($strpos_tmp < $SYS_LOG_VAR_ALIGN)
//          yes -- padding needed.
            ?
            (
               str_repeat(' ', (($SYS_LOG_VAR_ALIGN - $strpos_tmp) + 1))
            )
//          no -- padding NOT needed.
            :
            ('')
         )
//       no -- '#' char NOT found (no padding).
         : ('')
        )
        .
        $is
   );
}

function etoExit_sys_log_indent_var($is) // input string with leftmost '<' marking alignment point (e.g. "\$sys_exit_code<").
// function etoExit_sys_log_indent_var($is) // input string with leftmost '<' marking alignment point (e.g. "\$sys_exit_code<").
{
   global $SYS_LOG_VAR_ALIGN;

   $strpos_tmp = strpos($is, '<');

   return
   (
      (
//       '<' char found?
         (!($strpos_tmp === false))
//       yes -- '<' char found.
         ?
         (
//          is padding needed?
            ($strpos_tmp < $SYS_LOG_VAR_ALIGN)
//          yes -- padding needed.
            ?
            (
               str_repeat(' ', ($SYS_LOG_VAR_ALIGN - $strpos_tmp))
            )
//          no -- padding NOT needed.
            :
            ('')
         )
//       no -- '<' char NOT found (no padding).
         : ('')
        )
        .
        $is
   );
}

function etoExit_sys_log_msg()
{
   global $sys_script_id;
   global $sys_log_details;
   global $sys_log_det_val;
   global $sys_start_time;

   global $sys_exit_code;
   global $sys_exit_msg;

   global $sys_log_msg;
   global $sys_log_priority;
   global $sys_log_pr_name;
   global $sys_log_line_end;

   global $crn_dtime_utc;

   global $session_www_code;
   global $session_www_state;
   global $session_www_serno;

/*
@@@
$data = date("Y/m/d H:i:s");
syslog(LOG_DEBUG,"Messagge: $data");
@@@
*/

// Default $sys_exit_msg.
   (
       ($sys_exit_msg == '')
       &&
       ($sys_exit_code == 0)
   )
   ?   ($sys_exit_msg = 'EXIT_OK')
   :   false
   ;

// PHP script process ID.
   $sys_script_pid = getmypid();
   if (!$sys_script_pid)
   {
      $sys_script_pid = 0;
   }

// Log details.
//   (Reversible protection against content with embedded line end(s), breaking actual line end, so log line displays as multiple lines.)
// $sys_log_details_tmp = addcslashes($sys_log_details(), "\\\t\n\v\f\r"); // "\0x5C\0x09\0x0A\0x0B\0x0C\0x0D" (\,HT,LF,VT,FF,CR)
// $sys_exit_msg_tmp    = addcslashes($sys_exit_msg,      "\\\t\n\v\f\r"); // "\0x5C\0x09\0x0A\0x0B\0x0C\0x0D" (\,HT,LF,VT,FF,CR)

   $sys_log_msg
   =
   (         
//    '                                   ' .
      etoExit_sys_log_indent_var
      (
         "\$sys_exit_code<"     . "$sys_exit_code"       . "> " .
         "\$sys_script_pid<"    . "$sys_script_pid"      . "> " .
         "\$sys_log_priority<"  . "$sys_log_priority"    . "> " .
         "\$sys_log_pr_name<"   . "$sys_log_pr_name"     . "> "
      ) . $sys_log_line_end .          
//    '                                   ' .
      etoExit_sys_log_indent_var
      (
         "\$sys_script_id<"     . "$sys_script_id"       . "> " .
         "\$sys_eltim_secs<"    . (gettimeofday(true) - $sys_start_time) . "> "
      ) . $sys_log_line_end .          

//    '                               ' .
      etoExit_sys_log_indent_var
      (
         "\$session_www_state<" . "$session_www_state"   . "> " .
         "\$session_www_serno<" . "$session_www_serno"   . "> " .
         "\$crn_dtime_utc<"     . "$crn_dtime_utc"       . "> "
      ) . $sys_log_line_end .          

//    '                                ' .
      etoExit_sys_log_indent_var
      (
         "\$session_www_code<"  . "$session_www_code"    . "> "
      ) . $sys_log_line_end .          

//    '                               ' .
      etoExit_sys_log_indent_var
      (
         "\$sys_log_details()<"
         .
         (
//          are log details supplied?
            ($sys_log_det_val != '')
//          yes -- log details supplied (use value).
            ? ($sys_log_det_val)
//          no -- log details NOT supplied (probably abending -- call function).
            : ($sys_log_details())
//          : ($sys_log_detail())
         )
         . ">"
//       "\$sys_log_details()<" . addcslashes($sys_log_details(), "\\\t\n\v\f\r") . ">"
      )
   );

   return;
}

function etoExit_encap_log_msg()
{
   global $SYS_LOG_PREFIX;

   global $sys_exit_code;
   global $sys_exit_msg;
   global $sys_log_msg;
   global $sys_log_line_end;

   global $crn_dtime_utc;
   global $crn_dow_utc;
   global $crn_offset_loc;

   $sys_log_msg
   =
   (
      $SYS_LOG_PREFIX . "<" . $sys_exit_msg . "> " . $sys_log_line_end . // ** CAUTION ** Keep const SYS_LOG_VAR_NAME in sync with active use of variable (e.g. $sys_exit_msg) in this funcion etoExit_encap_log_msg().
//    $SYS_LOG_PREFIX . "<" . addcslashes($sys_exit_msg, "\\\t\n\v\f\r") . "> " . $sys_log_line_end . // ** CAUTION ** Keep const SYS_LOG_VAR_NAME in sync with active use of variable (e.g. $sys_exit_msg) in this funcion etoExit_encap_log_msg().

      "$sys_log_msg"
   );

   return;
}

function etoExit_error_log()
// function etoExit_HTTP_error_log()
{
// @@@ to do -- wrap $sys_log_msg in a format more compatible with Apache log analysis tools.

   global $sys_exit_code;
   global $sys_log_msg;

//  Log result of HTTP client request in web server error log.
//
//     *** NOTE ***
//
//     To ensure message gets to web server log,
//
//        php.ini setting MUST be:
//
//           error_log -- parameter value UNDEFINED
//
//        otherwise, the error_log() output goes to the PHP error file
//        and NOT to the web server error log.
//
   etoExit_encap_log_msg();

      $sys_log_msg_len = strlen($sys_log_msg);

// Does message length exceed error log limit?
   if ($sys_log_msg_len > ERROR_LOG_MSG_MAX_LEN)
// yes -- long message - log in chunks.
   {
      $chunk_msg_part_no = 1;

      $chunk_str_pos     = 0;

      while($chunk_str_pos < $sys_log_msg_len)
      {
         $chunk_pfx = 'Msg.Part.#' . $chunk_msg_part_no . ':';

         $chunk_rem_max_siz = (ERROR_LOG_MSG_MAX_LEN - strlen($chunk_pfx));

         $chunk_siz = ($sys_log_msg_len - $chunk_str_pos);

         ($chunk_siz > $chunk_rem_max_siz)
         ?
         ($chunk_siz = $chunk_rem_max_siz)
         :
         false
         ;

//       error_log() failure?
         if
         (
            !error_log
            (
               $chunk_pfx . substr($sys_log_msg, $chunk_str_pos, $chunk_siz),

               0 // => Apache error.log.
//             4 // => Apache error.log.
            )

         )
//       yes -- error_log() failure.
         {
//          Add 100000 to abend code -- indicate error_log failure.
	          $sys_exit_code += INT_BIT_19;
//           $sys_exit_code += 100000;

	          break;
         }

         $chunk_msg_part_no++;

         $chunk_str_pos += $chunk_siz;
      }
   }
   else
// no -- short message.
   {
//   error_log() failure?
      if
      (
         !error_log
         (
            $sys_log_msg,

            0 // => Apache error.log.
//          4 // => Apache error.log.
         )
      )
//    yes -- error_log() failure.
      {
//       Add 100000 to abend code -- indicate error_log failure.
	       $sys_exit_code += INT_BIT_19;
//        $sys_exit_code += 100000;
      }
   }

   return;
}

function etoExit_syslog()
{
   global $sys_exit_code;
   global $sys_log_msg;
   global $sys_log_priority;

   global $sys_log_line_end;
   global $sys_log_dir_sep;

   (PHP_WINDOWS_VERSION_PLATFORM >= 1) ?  ($sys_log_line_end = "\r\n") : ($sys_log_line_end = "\n");
   (PHP_WINDOWS_VERSION_PLATFORM >= 1) ?  ($sys_log_dir_sep  = "\\")   : ($sys_log_dir_sep = "/");

   (PHP_WINDOWS_VERSION_PLATFORM >= 1) ?  (etoExit_syslog_file()) : (etoExit_syslog_real());

/*
   etoExit_syslog_file();
   etoExit_syslog_real();
*/

   return;
}

function etoExit_syslog_file()
{
//
// *** NOTE ***
//
//   This function etoExit_syslog_file() is for
//
//     DEVELOPMENT AND DEBUGGING ONLY

//     and is NOT intended for muti-user produciton use.
//

   global $sys_exit_code;
   global $sys_log_msg;
   global $sys_log_dir_name;
   global $sys_log_line_end;
   global $sys_log_dir_sep;
   global $sys_log_file_path;

   global $crn_date_utc;

   clearstatcache();
   $fstat_stat = stat($sys_log_dir_name);
   clearstatcache();

// Did stat complete?
   if ($fstat_stat)
// yes -- stat completed.
   {
      $fstat_mode = $fstat_stat['mode'];

//    Is log directory accessible?
      if (FSTAT_S_IFDIR == ($fstat_mode & FSTAT_S_IFMT))
//    yes -- log directory accessible.
      {
         $sys_log_file_path
         =
         (
//          $sys_log_dir_name . ':' . SYS_LOG_NAME // Windows -- INvalid separator ':' - fopen() fails quietly, indicating success, without creating log file; subsequent fstat() indicates file mode is "regular" file => use stat() instead.
            $sys_log_dir_name . $sys_log_dir_sep . SYS_LOG_NAME
            .
            '_' . $crn_date_utc . '-utc'
            .
            '.log'
         );

         $sys_log_fh = fopen($sys_log_file_path, 'ab'); // 'a' -- Open for writing only. Place the file pointer at the end of the file. If the file does not exist, attempt to create it.  'b' --  binary mode - no translation of line end characters.

//       fopen() failure?
         if (!$sys_log_fh)
//       yes -- fopen() failure.
         {
//          Add 1000000 to abend code -- indicate fopen failure.
	          $sys_exit_code += INT_BIT_22;
//           $sys_exit_code += 1000000;
         }
         else
//       no -- fopen() "OK".
         {
            clearstatcache();
            $fstat_stat = stat($sys_log_file_path);
//          $fstat_stat = fstat($sys_log_fh); // fstat returns spurious results -- do NOT use.
            clearstatcache();

//          Did stat complete?
            if ($fstat_stat)
//          yes -- stat completed.
            {
               $fstat_mode = $fstat_stat['mode'];

//             Is log file INaccessible?
               if (FSTAT_S_IFREG != ($fstat_mode & FSTAT_S_IFMT))
//             yes -- log file INaccessible.
               {
//                indicate file stat failure - wrong mode returned.
	                $sys_exit_code += INT_BIT_23;
//                 $sys_exit_code += 10000000;
               }
               else
//             no -- log file accessible.
               {
                  etoExit_encap_log_msg();

//                fwrite() failure?
                  if
                  (
                     !fwrite
                     (
                        $sys_log_fh,

                        ($sys_log_msg . $sys_log_line_end)
                     )
                  )
//                yes -- fwrite() failure.
                  {
//                   Add 100000000 to abend code -- indicate fwrite failure.
	                   $sys_exit_code += INT_BIT_25;
//                    $sys_exit_code += 100000000;
                  }

//                fclose() failure?
                  if (!fclose($sys_log_fh))
//                yes -- fclose() failure.
                  {
//                  Add 1000000000 to abend code -- indicate fclose failure.
	                  $sys_exit_code += INT_BIT_26;
//                   $sys_exit_code += 1000000000;
                  }
               }
            }
            else
//          no -- stat INcomplete.
            {
//             Add 20000000 to abend code -- indicate file stat failure - call failed.
	             $sys_exit_code += INT_BIT_24;
//              $sys_exit_code += 20000000;
            }
         }
      }
      else
//    no -- log directory INaccessible - wrong stat mode.
      {
//       indicate directory stat() failure - wrong mode returned.
	       $sys_exit_code += INT_BIT_20;
//        $sys_exit_code += 200000;
      }
   }
   else
// no -- stat call INcomplete.
   {
//     indicate directory stat() failure - call failed.
	    $sys_exit_code += INT_BIT_21;
//     $sys_exit_code += 400000;
   }

   return;
}

function etoExit_syslog_real()
{
   global $sys_exit_code;
   global $sys_log_msg;
   global $sys_log_priority;

// define_syslog_variables(); -- deprecated function.

// openlog() failure?
   if (!openlog(SYS_LOG_NAME, LOG_NDELAY | LOG_PID, LOG_USER))
// yes -- openlog() failure.
   {
//     indicate openlog failure.
	    $sys_exit_code += INT_BIT_27;
//     $sys_exit_code += 200000;
   }
   else
// no -- openlog() OK.
   {
      etoExit_encap_log_msg();

      $sys_log_msg_len = strlen($sys_log_msg);

//    Does message length exceed syslog limit?
      if ($sys_log_msg_len > SYS_LOG_MSG_MAX_LEN)
//    yes -- long message - log in chunks.
      {
         $chunk_msg_part_no = 1;

         $chunk_str_pos     = 0;

         while($chunk_str_pos < $sys_log_msg_len)
         {
            $chunk_pfx = 'Msg.Part.#' . $chunk_msg_part_no . ':';

            $chunk_rem_max_siz = (SYS_LOG_MSG_MAX_LEN - strlen($chunk_pfx));

            $chunk_siz = ($sys_log_msg_len - $chunk_str_pos);

            ($chunk_siz > $chunk_rem_max_siz)
            ?
            ($chunk_siz = $chunk_rem_max_siz)
            :
            false
            ;

//          syslog() failure?
            if
            (
               !syslog
               (
                  $sys_log_priority,

                  $chunk_pfx . substr($sys_log_msg, $chunk_str_pos, $chunk_siz)
               )
            )
//          yes -- syslog() failure.
            {
//              indicate syslog failure.
	             $sys_exit_code += INT_BIT_28;
//              $sys_exit_code += 1000000;

	             break;
            }

            $chunk_msg_part_no++;

            $chunk_str_pos += $chunk_siz;
         }
      }
      else
//    no -- short message.
      {
//      syslog() failure?
         if
         (
            !syslog
            (
               $sys_log_priority,

               $sys_log_msg
            )
         )
//       yes -- syslog() failure.
         {
//           indicate syslog failure.
	          $sys_exit_code += INT_BIT_28;
//           $sys_exit_code += 1000000;
         }
      }

//   closelog() failure?
      if (!closelog())
//    yes -- closelog() failure.
      {
//        indicate closelog failure.
	       $sys_exit_code += INT_BIT_29;
//        $sys_exit_code += 10000000;
      }
   }

   return;
}

function etoAbend($ac, $xo = ABEND_EXIT, $ro = ABEND_ROLLBACK) // abend code, exit/noexit option, abend SQL rollback option.
{
   global $sys_exit_code;
	global $sys_exit_msg; // put in global context for <etoAbendReal($xo)>.

   $sys_exit_code = $ac;

   return(etoAbendReal($xo, $ro));
}

function etoAbendSubCode($ac, $sc, $xo = ABEND_EXIT, $ro = ABEND_ROLLBACK) // abend code, abend sub-code, exit/noexit option, abend SQL rollback option.
{

	global $sys_exit_code;
	global $sys_exit_msg; // put in global context for <etoAbendReal($xo)>.

   $sys_exit_code = ($ac + $sc);

   return(etoAbendReal($xo, $ro));
}

function etoAbendReal($xo = ABEND_EXIT, $ro = ABEND_ROLLBACK) // abend code, exit/noexit option, abend SQL rollback option.
{
	global $sys_exit_code;

	global $sys_exit_msg; // put in global context for <eto__abend_ssi_1.php>.

// Does caller want SQL rollback?
	if ($ro)
// yes -- rollback and close database.
	{
	   if (!etoSQLtrxRollback(0, false)) // dummy parameters (because already abending).
	   {
//       indicate rollback failure.
	      $sys_exit_code += INT_BIT_17;
//       $sys_exit_code += 2000;
	   }

     if (!etoSQLdbClose(0, false, false, SQL_NOCOMMIT)) // dummy, dummy, dummy, SQL commit option (dummy, ... because already abending).
     {
//       indicate close failure.
	      $sys_exit_code += INT_BIT_18;
//       $sys_exit_code += 10000;
     }
	}

// Does caller want to exit()?
  if ($xo)
// yes -- wants exit().
  {
     etoExit_parse_exit_code();

//   Display eto diagnostic page to visitor.
     require '../eto_php/eto__abend_ssi_1.php';

     etoExit();
  }
  else
// no -- wants return() of control.
  {
     return($sys_exit_code);
  }
}

function etoExit_parse_exit_code()
{
	global $sys_exit_code;

	global $sys_exit_app_code;
	global $sys_exit_flags_str;

// fetch application exit code value (use abs() to force positive sign bit, use modulus operator to extract app exit code).
   $sys_exit_app_code = (abs($sys_exit_code) % INT_BIT_17); // value from 0 ... 65535 16-bit no (will be -ve if dividend is -ve)).

// fetch flags value ...

// flag bits 17-31 (of $sys_exit_code) ...

   $tmp_exit_flags_int
   =
   (
      (abs($sys_exit_code) - $sys_exit_app_code)
      /
      INT_BIT_17
   );

	$sys_exit_flags_str
   =
   (
      str_pad
      (
         decbin($tmp_exit_flags_int),
         15,
         '0',
         STR_PAD_LEFT
       )
   );

// ... bits 17-31.

// flag bit 32 (of $sys_exit_code).
   $sys_exit_flags_str
   =
   (
      ($sys_exit_code < 0) ? '1' : '0'
      .
      $sys_exit_flags_str
   );

// ... fetch flags value.

   return;
}

// ... Functions.

?>
